package kd.hrmp.hbjm.business.domain.service.impl;

import com.google.common.collect.Lists;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.utils.ObjectUtils;
import kd.hr.hbp.business.application.impl.newhismodel.HisModelController;
import kd.hr.hbp.business.domain.model.newhismodel.BatchVersionChangeRespData;
import kd.hr.hbp.business.domain.model.newhismodel.HisResponse;
import kd.hr.hbp.business.domain.model.newhismodel.HisVersionParamBo;
import kd.hr.hbp.business.domain.model.newhismodel.HisVersionParamListBo;
import kd.hr.hbp.common.constants.HRBaseConstants;
import kd.hr.hbp.common.constants.newhismodel.HisFieldNameConstants;
import kd.hr.hbp.common.util.HRDynamicObjectUtils;
import kd.hrmp.hbjm.business.domain.service.IJobService;

import java.util.Arrays;
import java.util.List;

/**
 * @author rd_ningjie
 * @description:TODO
 * @date 2022/6/17 17:14
 */
public class JobServiceImpl implements IJobService {

    @Override
    public DynamicObject[] batchDisableJob(DynamicObject[] jobs) {

        return batchHisVersionChange(jobs);

    }

    /**
     * @param jobs
     * @description: 职位变更接口
     * @return: kd.bos.dataentity.entity.DynamicObject[]
     * @author rd_ningjie
     * @date: 2022/6/17 18:02
     */
    @Override
    public DynamicObject[] batchHisVersionChange(DynamicObject[] jobs) {
        if (ObjectUtils.isEmpty(jobs)) {
            return jobs;
        }
        HisVersionParamListBo hisVersionParamListBo = new HisVersionParamListBo();
        List<HisVersionParamBo> listHisVersionParamBo = Lists.newArrayList();
        HisVersionParamBo hisVersionParamBo = new HisVersionParamBo();
        String entitynumber = jobs[0].getDataEntityType().getName();
        hisVersionParamBo.setEntityNumber(entitynumber);
        List<DynamicObject> jobDynList = Lists.newArrayListWithExpectedSize(jobs.length);
        for (DynamicObject dyn : jobs) {
            DynamicObject newDyn = new DynamicObject(dyn.getDynamicObjectType());
            HRDynamicObjectUtils.copy(dyn, newDyn);
            newDyn.set(HisFieldNameConstants.BOID, dyn.getLong(HRBaseConstants.ID));
            jobDynList.add(newDyn);
        }
        hisVersionParamBo.setHisDyns(jobDynList.toArray(new DynamicObject[0]));
        listHisVersionParamBo.add(hisVersionParamBo);
        hisVersionParamListBo.setMainEntityNumber(entitynumber);
        hisVersionParamListBo.setListHisVersionParamBo(listHisVersionParamBo);
        HisResponse<BatchVersionChangeRespData> batchVersionChangeRespDataHisResponse = HisModelController.getInstance().batchHisVersionChange(hisVersionParamListBo);
        DynamicObject[] newDynamicObjects = batchVersionChangeRespDataHisResponse.getData().getVersionChangeRespDataList().get(0).getNewDynamicObjects();
        // 会生成当前和历史两个版本，取历史版本数据返回
        newDynamicObjects = Arrays.stream(newDynamicObjects).filter(dyn -> !dyn.getBoolean(HisFieldNameConstants.IS_CURRENT_VERSION)).toArray(DynamicObject[]::new);
        return newDynamicObjects;
    }

}
