package kd.hrmp.hbjm.business.utils;

import kd.bos.entity.AppInfo;
import kd.bos.entity.AppMetadataCache;
import kd.bos.entity.param.AppParam;
import kd.bos.servicehelper.org.OrgUnitServiceHelper;
import kd.bos.servicehelper.parameter.SystemParamServiceHelper;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author rd_ningjie
 * @version 1.0
 * @description: 系统参数获取
 * @date 2022/12/9 14:52
 */
public class HbjmSystemParamHelper {

    private static final String JOBNAMEVALIDE = "jobnamevalide";

    private static final String APPID_HJM = "hjm";

    /**
     * @description: 职位名称校验配置获取
     * @return: boolean
     * @author rd_ningjie
     * @date: 2022/12/9 15:46
     */
    public static boolean getJobNameValideParameterByRootId() {
        Object parameter = getParameterByRootOrg(JOBNAMEVALIDE);
        return parameter == null ? false : (Boolean) parameter;
    }

    /**
     * @description: 职位名称校验配置获取
     * @return: boolean
     * @author rd_ningjie
     * @date: 2022/12/9 15:46
     */
    public static Map<Long, Boolean> getJobNameValideParameterByOrgs(List<Long> orgIds) {
        Map<String, Map<String, Object>> parameters = getParameterByOrgs(orgIds);
        if (parameters == null) {
            return null;
        }
        Map<Long, Boolean> result = new HashMap<>(orgIds.size());
        for (Long orgId : orgIds) {
            Map<String, Object> params = parameters.get(String.valueOf(orgId));
            if (params != null) {
                Object ob = params.get(JOBNAMEVALIDE);
                result.put(orgId, (Boolean) ob);
            } else {
                result.put(orgId, Boolean.FALSE);
            }
        }
        return result;
    }

    public static Object getParameterByRootOrg(String param) {
        AppInfo appInfo = AppMetadataCache.getAppInfo(APPID_HJM);
        String appId = appInfo != null ? appInfo.getId() : null;
        Long orgPk = OrgUnitServiceHelper.getRootOrgId();
        AppParam appParam = new AppParam(appId, orgPk);
        return SystemParamServiceHelper.loadAppParameterFromCache(appParam, param);
    }

    public static Map<String, Map<String, Object>> getParameterByOrgs(List<Long> orgIds) {
        AppInfo appInfo = AppMetadataCache.getAppInfo(APPID_HJM);
        String appId = appInfo != null ? appInfo.getId() : null;
        AppParam appParam = new AppParam(appId, null);
        return SystemParamServiceHelper.loadBatchAppParameterByOrg(appParam, orgIds);
    }
}
