package kd.hrmp.hbjm.business.utils;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;

import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author rd_ningjie
 * @description:获取实体中非数据库字段
 * @date 2022/6/16 10:14
 */
public class JobDynamicObjectUtils {


    /**
     * @param obj
     * @description: 获取对象中非数据库字段
     * @return: Map<String, Object>
     * @author rd_ningjie
     * @date: 2022/6/16 10:17
     */
    public static Map<String, IDataEntityProperty> getNoDbCol(DynamicObject obj) {
        IDataEntityType type = obj.getDataEntityType();
        DataEntityPropertyCollection cols = type.getProperties();
        Map<String, IDataEntityProperty> result = new HashMap<>();
        result = cols.stream().filter(IDataEntityProperty::isDbIgnore)
                .collect(Collectors.toMap(IDataEntityProperty::getName, colInfo -> colInfo,(v1,v2)->v2));
        return result;
    }

}
