package kd.hrmp.hbjm.business.utils;

import kd.bos.context.RequestContext;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.permission.api.HasPermOrgResult;
import kd.bos.servicehelper.basedata.BaseDataServiceHelper;
import kd.bos.servicehelper.model.PermissionStatus;
import kd.bos.servicehelper.permission.PermissionServiceHelper;
import kd.bos.util.CollectionUtils;
import kd.hr.hbp.common.constants.HRBaseConstants;

import java.util.List;

public class PermHelper {
    private final static String HR_ORG_VIEW_TYPE = "21";

    public static HasPermOrgResult getHRPermOrg(String appId, String entityNumber) {
        return getHRPermOrg(RequestContext.get().getCurrUserId(), appId, entityNumber, PermissionStatus.View);
    }

    public static HasPermOrgResult getHRPermOrg(long userId, String appId, String entityNumber, String permId) {
        return PermissionServiceHelper.getAllPermOrgs(userId, HR_ORG_VIEW_TYPE, appId, entityNumber, permId, false);
    }

    /**
     * 特别处理了行政组织主数据，因其是非受控基础资料，但又受到BU限制（以haos_adminorgdetail为识别key
     *
     * @param entityName 元数据编码
     * @param orgIdList  业务单元id集合
     * @return 基础资料 QFilter
     */
    public static QFilter getBaseDataFilter(String entityName, List<Long> orgIdList) {
        if (CollectionUtils.isEmpty(orgIdList)) {
            // 1 != 1
            return new QFilter(HRBaseConstants.STR_ONE, QCP.not_equals, HRBaseConstants.INT_ONE);
        }

        if (orgIdList.size() == 1) {
            return BaseDataServiceHelper.getBaseDataFilter(entityName, orgIdList.get(0));
        } else {
            return BaseDataServiceHelper.getBaseDataFilter(entityName, orgIdList, true);
        }
    }
}
